/*
	a200_switch.h - common definitions used in this application.
*/
#ifndef A200_SWITCH_H
#define A200_SWITCH_H

enum DEBUG_FLAGS{
	INFO=1,
	ERR,
	DBG_IFACE,
	DBG_MAIN
};

#define DEV_NAME_LEN			100

//in this program we limit number of interfaces
#define MAX_NUM_OF_FXS			2
#define MAX_NUM_OF_FXO			MAX_NUM_OF_FXS
#define MAX_NUM_OF_INTERFACES	(MAX_NUM_OF_FXS + MAX_NUM_OF_FXO)

#define PORT0	0
#define PORT1	1

//ALL possible switch states:
typedef enum SWITCH_STATE{
	SW_ST_RESET=1,
	SW_ST_FXS_PORT0_TO_FXS_PORT1_DIALING,
	SW_ST_FXS_PORT0_TO_FXS_PORT1_CONNECTED,
	SW_ST_PSTN_IS_RINGING,
	SW_ST_FXS_PORT0_TO_FXO_PORT0
};

#define EVENT_DELAY()	Sleep(1000)

#define DECODE_SWITCH_STATE(state)													\
	(state == SW_ST_RESET)								? "SW_ST_RESET" :					\
	(state == SW_ST_FXS_PORT0_TO_FXS_PORT1_DIALING)		? "SW_ST_FXS_PORT0_TO_FXS_PORT1_DIALING"  :	\
	(state == SW_ST_FXS_PORT0_TO_FXS_PORT1_CONNECTED)	? "SW_ST_FXS_PORT0_TO_FXS_PORT1_CONNECTED"  :	\
	(state == SW_ST_PSTN_IS_RINGING)					? "SW_ST_PSTN_IS_RINGING"  :	\
	(state == SW_ST_FXS_PORT0_TO_FXO_PORT0)				? "SW_ST_FXS_PORT0_TO_FXO_PORT0"  : "Unknown"


extern void cli_out(unsigned int dbg_flag, void *pszFormat, ...);
extern unsigned int verbosity_level;


typedef struct{
	int		(*got_rx_data)(void *sang_if_ptr, void *rx_data);
	void	(*got_TdmApiEvent)(void *sang_if_ptr, void *event_data);
}callback_functions_t;

#endif//A200_SWITCH_H
